using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using MacGruber;
using UnityEngine;
using SimpleJSON;
using MVR.FileManagementSecure;
using UnityEngine.Serialization;
using Random = UnityEngine.Random;


namespace CheesyFX {

	public class ReadMyLips : MVRScript
	{
		public static ReadMyLips singleton;
		private GenerateDAZMorphsControlUI morphControl;
		private static System.Random rng = new System.Random();  
		// private static Dictionary<JSONStorableFloat, float> painMorphps= new Dictionary<JSONStorableFloat, float>();
		// private static Dictionary<JSONStorableFloat, float> joyMorphs= new Dictionary<JSONStorableFloat, float>();
		// private static Dictionary<JSONStorableFloat, float> lastMorphs= new Dictionary<JSONStorableFloat, float>();
		private static List<Morph> painMorphs = new List<Morph>();
		private static List<Morph> joyMorphs = new List<Morph>();
		private static List<Morph> lastMorphs = new List<Morph>();
		private static JSONStorableBool autoJaw = new JSONStorableBool("Auto Jaw", true);
		public static JSONStorableFloat maxMorphVal = CheesyUtils.SetupJSONFloat("Max Morph Value", .15f, 0f, 1f);
		public static JSONStorableFloat painTreshold = CheesyUtils.SetupJSONFloat("Pain Thresold", .7f, 0f, 1f, true);
		public static JSONStorableFloat joyExpressionScale = CheesyUtils.SetupJSONFloat("Joy Expression Scale", 20f, 1f, 40f, true);
		public static JSONStorableFloat painExpressionScale = CheesyUtils.SetupJSONFloat("Pain Expression Scale", 7f, 1f, 10f, true);
		public static JSONStorableFloat expressionsChangeChance = new JSONStorableFloat("Expression Change Chance", .1f, 0f, 1f);
		public static JSONStorableFloat randomBurstChanceJ = new JSONStorableFloat("Random Burst Chance", .7f, 0f, 1f);
		public static JSONStorableFloat randomBurstStrenght = new JSONStorableFloat("Random Burst Strength", 5f, 0f, 10f);
		
		public static JSONStorableFloat slapMoanChance = new JSONStorableFloat("Slap Moan Chance", .5f, 0f, 1f, true);
		public static JSONStorableFloat sexSlapMoanChance = new JSONStorableFloat("Sex Slap Moan Chance", .4f, 0f, 1f, true);

		public static JSONStorableFloat stimulation = new JSONStorableFloat("Stimulation", 0f, 0f, 1f, true, false);
		public static bool isReset = false;
		private static float resetTargetsTimer = 1f;
		private static float stimBurstTimer;
		public static float randomBurstChance;
		
		private bool vammoanPackageInstalled;
		public static ClipLibrary moanLibrary;
		public static AudioSource headAudioSource;
		public static JSONStorableStringChooser vamMoanVoice;
		public static JSONStorableStringChooser voice = new JSONStorableStringChooser("vammoanSlapVoice",
			new List<string>{"Abby", "Claire", "Ella", "Emma", "Grace", "Isabella", "Lana", "Lia", "Lillian", "Lise", "Seth", "Skye", "Yumi"},
			"Isabella", "VAMMoan Voice");
		
		public static DAZMeshEyelidControl eyelidBehavior;
		private static AdjustJoints jawControl;
		// private static JSONStorable autoJawMouthMorphs;
		public static float blinkTimeout;
		private List<object> UIElements = new List<object>();
		private UIDynamicTabBar tabbar;

		public override void Init()
		{
			UIManager.SetScript(this, CreateUIElement, leftUIElements, rightUIElements);
			singleton = this;
			eyelidBehavior = (DAZMeshEyelidControl) containingAtom.GetStorableByID("EyelidControl");
			jawControl = (AdjustJoints)containingAtom.GetStorableByID("JawControl");
			jawControl.SetBoolParamValue("driveXRotationFromAudioSource", true);
			jawControl.SetFloatParamValue("driveXRotationFromAudioSourceMaxAngle", -15f);
			// autoJawMouthMorphs = containingAtom.GetStorableByID("AutoJawMouthMorph");
			DAZCharacterSelector characterSelector = SlapMe.atom.GetStorableByID("geometry") as DAZCharacterSelector;
			morphControl = characterSelector.morphsControlUI;
			string joyMorphPath = SlapMe.packageUid + "Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Expressions/Joy/";
			string painMorphPath = SlapMe.packageUid + "Custom/Atom/Person/Morphs/female/CheesyFX/BodyLanguage/Expressions/Displease";
			foreach (var path in FileManagerSecure.GetFiles(joyMorphPath + "Ascorad"))
			{
				if(path.EndsWith(".vmb")) continue;
				var pathNormalized = FileManagerSecure.NormalizePath(path);
				joyMorphs.Add(GetMorph(pathNormalized));
			}
			foreach (var path in FileManagerSecure.GetFiles(joyMorphPath + "AshAuryn"))
			{
				if(path.EndsWith(".vmb")) continue;
				var pathNormalized = FileManagerSecure.NormalizePath(path);
				joyMorphs.Add(GetMorph(pathNormalized));
			}
			foreach (var path in FileManagerSecure.GetFiles(painMorphPath))
			{
				if(path.EndsWith(".vmb")) continue;
				var pathNormalized = FileManagerSecure.NormalizePath(path);
				painMorphs.Add(GetMorph(pathNormalized));
			}
			joyMorphs.Add(GetMorph("Desire"));
			joyMorphs.Add(GetMorph("Excitement"));
			joyMorphs.Add(GetMorph("Flirting"));
			joyMorphs.Add(GetMorph("Flirting Feminine Left"));
			joyMorphs.Add(GetMorph("Flirting Feminine Right"));
			joyMorphs.Add(GetMorph("Flirting Masculine Left"));
			joyMorphs.Add(GetMorph("Flirting Masculine Right"));
			joyMorphs.Add(GetMorph("Frown"));
			joyMorphs.Add(GetMorph("Sad"));
			joyMorphs.Add(GetMorph("Scream"));
			joyMorphs.Add(GetMorph("Shock"));
			joyMorphs.Add(GetMorph("Smile Full Face"));
			joyMorphs.Add(GetMorph("Snarl Left"));
			joyMorphs.Add(GetMorph("Snarl Right"));
			joyMorphs.Add(GetMorph("Surprise"));
			
			// joyMorphpsBrows.Add(GetMorph("Brow Down"));
			joyMorphs.Add(GetMorph("Brow Down Left"));
			joyMorphs.Add(GetMorph("Brow Down Right"));
			// joyMorphps.Add(GetMorph("Brow Inner Down"));
			joyMorphs.Add(GetMorph("Brow Inner Down Left"));
			joyMorphs.Add(GetMorph("Brow Inner Down Right"));
			joyMorphs.Add(GetMorph("Brow Inner Up Left"));
			joyMorphs.Add(GetMorph("Brow Inner Up Right"));
			// joyMorphps.Add(GetMorph("Brow Outer Down Left"));
			joyMorphs.Add(GetMorph("Brow Outer Down Left"));
			joyMorphs.Add(GetMorph("Brow Outer Down Right"));
			// joyMorphps.Add(GetMorph("Brow Outer Up"));
			joyMorphs.Add(GetMorph("Brow Outer Up Left"));
			joyMorphs.Add(GetMorph("Brow Outer Up Right"));
			// joyMorphps.Add(GetMorph("Brow Up"));
			joyMorphs.Add(GetMorph("Brow Up Left"));
			joyMorphs.Add(GetMorph("Brow Up Right"));
			joyMorphs.Add(GetMorph("Brow Squeeze"));
			
			joyMorphs.Add(GetMorph("Eyes Closed"));
			joyMorphs.Add(GetMorph("Eyes Squint"));
			joyMorphs.Add(GetMorph("Eyes Squint Left"));
			joyMorphs.Add(GetMorph("Eyes Squint Right"));
			
			// joyMorphs.Add(GetMorph("Mouth Open"));
			// joyMorphs.Add(GetMorph("Mouth Open Wide"));
			// joyMorphs.Add(GetMorph("Mouth Narrow"));
			// joyMorphs.Add(GetMorph("Mouth Narrow Left"));
			// joyMorphs.Add(GetMorph("Mouth Narrow Right"));
			joyMorphs.Add(GetMorph("Mouth Side-Side Left"));
			joyMorphs.Add(GetMorph("Mouth Side-Side Right"));
			joyMorphs.Add(GetMorph("Mouth Smile"));
			joyMorphs.Add(GetMorph("Mouth Smile Open"));
			// joyMorphs.Add(GetMorph("Mouth Smile Simple"));
			joyMorphs.Add(GetMorph("Mouth Smile Simple Left"));
			joyMorphs.Add(GetMorph("Mouth Smile Simple Right"));
			
			joyMorphs.Add(GetMorph("Lip Bottom Down"));
			joyMorphs.Add(GetMorph("Lip Bottom Out"));
			// joyMorphps.Add(GetMorph("Lip Bottom In"));
			joyMorphs.Add(GetMorph("Lip Bottom In Left"));
			joyMorphs.Add(GetMorph("Lip Bottom Out Right"));
			joyMorphs.Add(GetMorph("Lip Bottom Up"));
			joyMorphs.Add(GetMorph("Lip Bottom Up Left"));
			joyMorphs.Add(GetMorph("Lip Bottom Up Right"));
			// joyMorphs.Add(GetMorph("Lip Top Up"));
			joyMorphs.Add(GetMorph("Lip Top Up Left"));
			joyMorphs.Add(GetMorph("Lip Top Up Right"));
			joyMorphs.Add(GetMorph("Lips Close"));
			joyMorphs.Add(GetMorph("Lips Part"));
			// joyMorphs.Add(GetMorph("Lips Pucker"));
			joyMorphs.Add(GetMorph("Lips Pucker Wide"));
			enabledJSON.setCallbackFunction += val => Reset();
			
			headAudioSource = containingAtom.GetStorableByID("HeadAudioSource").GetComponent<AudioSource>();
			moanLibrary = new ClipLibrary("moans");
			
			var vammoan = this.FindPluginPeer("VAMMoan");
			if (vammoan)
			{
				vamMoanVoice = vammoan.GetStringChooserJSONParam("voice");
				voice.val = vamMoanVoice.val;
				vamMoanVoice.setCallbackFunction += val => voice.val = val;
			}
			else RetrySyncWithVamMoan().Start();
			voice.setCallbackFunction += val =>
			{
				AudioImporter.ReadBundle("VAMMoan", moanLibrary);
				if (vamMoanVoice != null) vamMoanVoice.val = val;
			};
			
			string vamMoanPackageUid = CheesyUtils.GetLatestPackageUid("hazmhox.vammoan");
			if (vamMoanPackageUid != null)
			{
				vammoanPackageInstalled = true;
				string moanPath = vamMoanPackageUid + ":/Custom/Scripts/VAMMoan/audio/voices.voicebundle";
				AudioImporter.GetClipsFromAssetBundle(moanLibrary, moanPath);
				var squishPath = vamMoanPackageUid + ":/Custom/Scripts/VAMMoan/audio/voices-shared.voicebundle";
				AudioImporter.GetClipsFromAssetBundle(new List<ClipLibrary>{FillMeUp.squishLibrary, FillMeUp.bjLibrary},
					squishPath);
			}
			else
			{
				vammoanPackageInstalled = false;
				ReadMyLips.slapMoanChance.val = 0f;
				ReadMyLips.sexSlapMoanChance.val = 0f;
			}
			slapMoanChance.setCallbackFunction += val =>
			{
				if (!vammoanPackageInstalled)
				{
					SuperController.LogError("SlapMe: Download VAMMoan to enable moan reactions.");
					slapMoanChance.valNoCallback = 0f;
				}
			};
			sexSlapMoanChance.setCallbackFunction += val =>
			{
				if (!vammoanPackageInstalled)
				{
					SuperController.LogError("SlapMe: Download VAMMoan to enable moan reactions.");
					sexSlapMoanChance.valNoCallback = 0f;
				}
			};
			randomBurstChanceJ.setCallbackFunction += val => randomBurstChance = .01f * val;
			randomBurstChance = .01f * randomBurstChanceJ.val;
			lastMorphs.Add(joyMorphs[0]);
			
			RegisterFloat(randomBurstChanceJ);
			RegisterFloat(randomBurstStrenght);
			RegisterFloat(joyExpressionScale);
			RegisterFloat(painTreshold);
			RegisterFloat(painExpressionScale);
			RegisterFloat(maxMorphVal);
			RegisterFloat(expressionsChangeChance);
			CreateUI();
			Reset();
		}
		
		private void CreateUI()
		{
			stimulation.CreateUI(this);
			painTreshold.CreateUI(this, true);
			tabbar = UIManager.CreateTabBar(new [] {"Expressions", "Voice"}, SelectTab, script:this);
			tabbar.SelectTab(0);
		}

		private void SelectTab(int id)
		{
			Utils.RemoveUIElements(this, UIElements);
			if (id == 0) CreateExpressionsUI();
			else CreateVoiceUI();
		}

		private void CreateExpressionsUI()
		{
			joyExpressionScale.CreateUI(this, UIElements:UIElements);
			painExpressionScale.CreateUI(this, UIElements:UIElements, rightSide:true);
			maxMorphVal.CreateUI(this, UIElements:UIElements);
			expressionsChangeChance.CreateUI(this, UIElements:UIElements, rightSide:true);
			randomBurstChanceJ.CreateUI(this, UIElements:UIElements);
			randomBurstStrenght.CreateUI(this, UIElements:UIElements, rightSide:true);
		}
		
		private void CreateVoiceUI()
		{
			slapMoanChance.CreateUI(script: this, UIElements:UIElements);
			sexSlapMoanChance.CreateUI(script: this, rightSide:true, UIElements:UIElements);
			voice.CreateUI(script: this, rightSide:true, chooserType:1, UIElements:UIElements);
		}

		public static void Stimulate(float stimulus, bool doChange = false){
			float stim = stimulus * .01f;
			
			isReset = false;
			stimBurstTimer = .2f;
			if (doChange)
			{
				if (stimulation.val <= .01f)
				{
					resetTargetsTimer = stimBurstTimer = Random.Range(.5f, 4f);
				}
				resetTargetsTimer = 1f;
			}
			DistributeStimulus(stim, doChange);
			stimulation.val += stim;
		}

		public static void DistributeStimulus(float stim, bool doChange){
			float available = stim;
			List<Morph> morphs;
			float factor;
			if(stimulation.val > painTreshold.val){
				morphs = new List<Morph>(painMorphs);
				factor = painExpressionScale.val;
				// factor = Mathf.Lerp(painExpressionScale.val, painExpressionScale.val * .25f,
				// 	(stimulation.val - painTreshold.val)/(1f - painTreshold.val));
			}
			else{
				morphs = new List<Morph>(joyMorphs);
				factor = Mathf.Lerp(joyExpressionScale.val*1.5f, joyExpressionScale.val * .25f, stimulation.val);
			}

			
			available *= factor;
			List<Morph> rndMorphs;
			if (!doChange && Random.Range(0f, 1f) > expressionsChangeChance.val)
			{
				foreach(var morph in lastMorphs)
				{
					float increment = Random.Range(0f, Math.Min(available, Mathf.Abs(maxMorphVal.val - morph.target)));
					morph.target += increment;
					available -= increment;
					if (available <= .01f) break;
				}
			}
			else
			{
				// rndMorphs = morphs.OrderBy(x => rng.Next()).ToList();
				lastMorphs.Clear();
				for (var i = 0; i < morphs.Count; i++)
				{
					var morph = morphs[rng.Next(morphs.Count)];
					float increment = Random.Range(.05f, Math.Min(available, Mathf.Abs(maxMorphVal.val - morph.target)));
					morph.target += increment;
					available -= increment;
					lastMorphs.Add(morph);
					if (available <= .05f) break;
				}
				// lastMorphs.Count.Print();
			}
			// foreach(var morph in rndMorphs)
			// {
			// 	float increment = Random.Range(0f, Math.Min(available, Mathf.Abs(maxMorphVal.val - morph.target)));
			// 	morph.target += increment;
			// 	available -= increment;
			// 	lastMorphs.Add(morph);
			// 	if (available <= .01f) break;
			// }
			if(targetsReset) targetsReset = false;
		}

		private static bool targetsReset;
		public void Update(){
			if(enabled)
			{
				// if(lastMorphs[0].target >0f) lastMorphs[0].target.Print();
				if(blinkTimeout > 0f) blinkTimeout -= Time.deltaTime;
				if(stimulation.val > .01f){
					stimulation.val = Mathf.Lerp(stimulation.val, 0f, Time.deltaTime);
				}
				// if(lastMorphs[0].target >0f) lastMorphs[0].target.Print();
				// else if(!isReset) ResetTargets();
				if(resetTargetsTimer > 0f) resetTargetsTimer -= Time.deltaTime;
				if(stimBurstTimer > 0f) stimBurstTimer -= Time.deltaTime;
				// if(lastMorphs[0].target >0f) lastMorphs[0].target.Print();
				foreach(var morph in painMorphs)
				{
					morph.LerpToTarget();
				}
				foreach(var morph in joyMorphs){
					// if(morph.target > 0f) $"{morph.name} {morph.target} {morph.val}".Print();
					morph.LerpToTarget();
					
				}
				if(!targetsReset && (resetTargetsTimer <= 0f || stimBurstTimer <= 0f))
				{
					foreach(var morph in painMorphs){
						if(morph.target > 0f) morph.target = 0f;
					}
					foreach(var morph in joyMorphs){
						if(morph.target > 0f) morph.target = 0f;
					}
					targetsReset = true;
					resetTargetsTimer = 1f;
				}
			}
			
		}

		// void AdjustNipples(float erection){
		// 	nippleSpring.val = Mathf.Lerp(nippleSpring.defaultVal, 15f, erection);
		// 	nippleDamper.val = Mathf.Lerp(nippleDamper.defaultVal, 3f, erection);
		// 	nippleMorph.jsonFloat.val = erection;
		// }

		private void ResetTargets()
		{
			foreach(var morph in painMorphs)
			{
				morph.target = 0f;
			}
			
			foreach (var morph in joyMorphs)
			{
				morph.target = 0f;
			}
			isReset = true;
		}

		public static void Reset(){
			foreach(var morph in painMorphs)
			{
				morph.val = 0f;
				morph.target = 0f;
			}
			
			foreach (var morph in joyMorphs)
			{
				morph.val = 0f;
				morph.target = 0f;
			}
			stimulation.val = 0f;
			isReset = true;
		}

		private Morph GetMorph(string uid)
		{
			DAZMorph morph = morphControl.GetMorphByUid(uid);
			if (morph == null) uid.Print();
			return new Morph(morph);
		}

		public static void PlayMoan(bool isSexSlap = false)
		{
			if(FillMeUp.throat.depth.val > .02f || headAudioSource.isPlaying) return;
			bool doMoan;
			if (isSexSlap) doMoan = sexSlapMoanChance.val > 0f && Random.Range(0f, 1f) < sexSlapMoanChance.val;
			else doMoan = slapMoanChance.val > 0f && Random.Range(0f, 1f) < slapMoanChance.val;
			if(doMoan) moanLibrary.Play(headAudioSource);
		}
		
		private IEnumerator RetrySyncWithVamMoan()
		{
			yield return new WaitForEndOfFrame();
			for (int i = 0; i < 5; i++)
			{
				yield return new WaitForSeconds(2f);
				var vammoan = this.FindPluginPeer("VAMMoan");
				if (vammoan)
				{
					vamMoanVoice = vammoan.GetStringChooserJSONParam("voice");
					voice.val = vamMoanVoice.val;
					vamMoanVoice.setCallbackFunction += val => voice.val = val;
					yield break;
				}
			}
		}
	}
	
	public class Morph
	{
		private DAZMorph dazMorph;
		private bool isAtTarget;
		public string name => dazMorph.displayName;
		private float _target;
		public float target
		{
			get { return _target; }
			set
			{
				if (_target == value) return;
				_target = value;
				isAtTarget = false;
			}
		}

		public float val
		{
			get { return dazMorph.morphValue; }
			set { dazMorph.morphValue = value; }
		}

		public Morph(DAZMorph dazMorph)
		{
			this.dazMorph = dazMorph;
		}

		public void LerpToTarget()
		{
			if (!isAtTarget && Mathf.Abs(val - _target) < .001f)
			{
				val = _target;
				isAtTarget = true;
				return;
			}
			if(_target > 0) val = Mathf.Lerp(val, _target, 4f*Time.deltaTime);
			else val = Mathf.Lerp(val, _target, 2f*Time.deltaTime);
		}
	}
}