using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MacGruber;
using SimpleJSON;
using UnityEngine;
using Random = UnityEngine.Random;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;

namespace CheesyFX
{
    public class SlapMe : MVRScript
    {
        public static SlapMe singleton;
        public static Atom atom;
        private static Transform labia;
        
        public static JSONStorableBool feetSlapsEnabled = new JSONStorableBool("Feet Slaps Enabled", false);
        public static JSONStorableBool selfSlapsEnabled = new JSONStorableBool("Self Slaps Enabled (Hands)", true);
        public static JSONStorableBool slapVocalsEnabled = new JSONStorableBool("Slap Vocal Reaction Enabled", false);
        // public static JSONStorableBool slapMoanEnabled = new JSONStorableBool("Slap Moans Enabled", true);
        // public static JSONStorableBool sexSlapMoanEnabled = new JSONStorableBool("Sex Slap Moans Enabled", true);
        public static JSONStorableBool isSlappingOthers = new JSONStorableBool("Slap Others Enabled", true);
        public static JSONStorableFloat slapVolume = new JSONStorableFloat("Slap Volume", 1f, 0f, 10f, false);
        public static JSONStorableFloat sexSlapVolume = new JSONStorableFloat("Sex Slap Volume", .3f, 0f, 10f, false);
        public static JSONStorableFloat sexSlapThreshold = new JSONStorableFloat("Sex Slap Threshold", .1f, 0f, .2f, false);
        public static JSONStorableFloat slapThreshold = new JSONStorableFloat("Slap Threshold", 1f, 0f, 2f, false);

        public static List<Atom> excludedAtoms = new List<Atom>();
        private JSONStorableString excludedInfo = new JSONStorableString("excludeInfo", "");

        private JSONStorableStringChooser excludedChooser =
	        new JSONStorableStringChooser("atomChooser", null, "", "Select Atom");

        // public static JSONStorableStringChooser vammoanSlapVoice =
	       //  new JSONStorableStringChooser("vammoanSlapVoice", null, "Isabella", "VAMMoan Voice");

        private static float sexSlapIntensity;
        AudioSource slapAS;
        private static AudioSource sexSlapAS;
        private static IEnumerator sexSlap;
        private static IEnumerator pussySlap;
        
        public static ClipLibrary slapLibrary;
        public static ClipLibrary sexSlapLibrary;
        public static ClipLibrary buttSlapLibrary;

        public static ReadMyLips readMyLips;
        
        public static string packageUid;
        
        public override void Init()
        {
            singleton = this;
            atom = containingAtom;
            labia = atom.rigidbodies.First(x => x.name == "LabiaTrigger").transform;
            packageUid = Utils.GetPackagePath(this);

            slapLibrary = new ClipLibrary("slaps");
            sexSlapLibrary = new ClipLibrary("sexslaps");
            buttSlapLibrary = new ClipLibrary("buttslaps");
            
            var slapsPath = packageUid + "Custom/Scripts/CheesyFX/BodyLanguage/audiobundles/slaps.audiobundle";
            AudioImporter.GetClipsFromAssetBundle(new List<ClipLibrary>{slapLibrary, sexSlapLibrary, buttSlapLibrary},
	            slapsPath);

            excludedChooser.choices = SuperController.singleton.GetAtomUIDs();
            SuperController.singleton.onAtomAddedHandlers += AddExclusionChoice;
            SuperController.singleton.onAtomUIDsChangedHandlers += SyncAtomNames;
            
            RegisterBool(feetSlapsEnabled);
            RegisterBool(selfSlapsEnabled);
            RegisterFloat(slapVolume);
            RegisterFloat(sexSlapVolume);
            RegisterString(excludedInfo);
            excludedInfo.isRestorable = false;
            RegisterStringChooser(excludedChooser);
            CreateUI();
            // SuperController.singleton.GetAtomByUid("AptSofa").type.Print();
            Exclude("AptSofa", true);
            ExcludeDefaults();
        }

        private void CreateUI()
        {
	        slapVolume.CreateUI(script:this);
	        sexSlapVolume.CreateUI(script:this, rightSide:true);
	        // UIManager.SetupInfoOneLine(null, "Expressions", false, false, this);
	        // var textfield = CreateTextField(new JSONStorableString("", "Expressions"));
	        // textfield.height = 50f;
	        // textfield.UItext.alignment = TextAnchor.MiddleCenter;
	        
	        var button = CreateButton("Disable Touches with...");
	        button.button.onClick.AddListener(() => Exclude(excludedChooser.val, true));
	        button = CreateButton("Enable Touches with...");
	        button.button.onClick.AddListener(() => Exclude(excludedChooser.val, false));
	        excludedChooser.CreateUI(script: this, rightSide: true,chooserType:2);
	        button = CreateButton("Reset");
	        button.button.onClick.AddListener(ResetExcluded);
	        var textfield = CreateTextField(excludedInfo, true);
	        textfield.height = 400f;
	        selfSlapsEnabled.CreateUI(this);
	        feetSlapsEnabled.CreateUI(this);
        }
        
        public static void Slap(TouchZone touchZone, Collision collision)
        {
	        if (!feetSlapsEnabled.val && touchZone.parents.Any(x => x.name == "Feet")) return;
			ContactPoint contactPoint = collision.contacts[0];
			Vector3 velocity = collision.relativeVelocity;
			float intensity = Math.Abs(Vector3.Dot(velocity, contactPoint.normal));
			if (intensity < sexSlapThreshold.val) return;
			// if(intensity < .01f) return;
			AudioSource audioSource = touchZone.slapAudioSource;
			audioSource.transform.position = contactPoint.point;
			Atom collidingAtom = collision.rigidbody.GetAtom();
			bool contactWithPerson = collidingAtom.type == "Person";
			bool slapsOtherPerson = contactWithPerson && touchZone.parents.Any(x => x.name.Contains("Hand"));
			string collidingRegion = collision.rigidbody.GetRegionName();
			bool slappedByHand = collidingRegion.Contains("Hand");// || collidingRegion.Contains("Thumb") || collidingRegion.Contains("Index") || collidingRegion.Contains("Mid") || collidingRegion.Contains("Ring") || collidingRegion.Contains("Pinky");
			bool selfSlap = collidingAtom == atom;
			bool slappedByPerson =
				(contactWithPerson &&
				 (slappedByHand || collidingRegion.Contains("Arm"))) ||
				collidingAtom.type == "Dildo" || collidingAtom.type == "Paddle" || collidingAtom.type == "Capsule";
			bool collidingAtomIsPenetrating = FillMeUp.penetratingAtoms.Values.ToList().Contains(collidingAtom);
			
			if (collidingAtomIsPenetrating &&
			    (collidingRegion == "Penis" || collidingRegion == "DildoPenis")) return;
			if(
				collidingAtomIsPenetrating
				&& collidingRegion != null
				&& (collidingRegion == "Pelvis" || collidingRegion == "Abdomen"  || collidingRegion.Contains("Thigh") || collidingRegion == "Testes" || collidingRegion == "DildoSack"))
			{
				if ((touchZone.name.Contains("Thigh") || touchZone.name.Contains("Glutes") ||
				     touchZone.name == "Labia" || touchZone.name == "Anus" || touchZone.name == "Vagina"))
				{
					if (intensity < sexSlapIntensity) return;
					sexSlapIntensity = intensity;
					sexSlapAS = audioSource;
					if (sexSlap == null) sexSlap = SexSlap().Start();

				}
			}
			if(Vector3.Distance(labia.position, contactPoint.point) < .15f)
			{
				if(intensity < sexSlapIntensity) return;
				sexSlapIntensity = intensity;
				sexSlapAS = audioSource;
				if (pussySlap == null) pussySlap = PussySlap().Start();
			}
			else{
				if(intensity < slapThreshold.val) return;
				float direction = intensity / velocity.magnitude;
				// (collision.rigidbody.name+"->"+touchZone.name).Print();
				List<BodyRegion> touchedParents = touchZone.parents;
				if (touchedParents.Any(x => x.name.Contains("Hand")) ||
				    touchedParents.Any(x => x.name.Contains("ForeArm")))
				{
					if (!slapsOtherPerson || !isSlappingOthers.val) return;
				}
				bool slappedByOtherPerson = !selfSlap && slappedByPerson;
				touchZone.Slap(intensity, direction, touchZone,slapVocalsEnabled.val && slappedByOtherPerson, slappedByOtherPerson);
			}
		}
        
        private static IEnumerator PussySlap(){
	        AudioClip clip = buttSlapLibrary.GetRandomClip();
	        yield return new WaitForSeconds(.05f);
	        float volumeFactor = sexSlapIntensity*sexSlapIntensity*sexSlapVolume.val*1.3f;
	        sexSlapAS.pitch = Mathf.Lerp(1.2f, 1.5f, sexSlapIntensity);
	        // volumeFactor.Print();
	        // sexSlapIntensity.Print();
	        sexSlapAS.PlayOneShot(clip, volumeFactor);
	        var vagAS = FillMeUp.vagina.audioSource;
	        if (vagAS == null)
	        {
		        sexSlapIntensity = 0f;
		        pussySlap = null;
		        yield break;
	        }
	        vagAS.volume = Mathf.Lerp(.75f, 1f,sexSlapIntensity);
	        
	        vagAS.PlayOneShot(FillMeUp.squishLibrary.GetRandomClip());
	        
	        // if(globalSlapMoanReactionEnabled.val) AudioManager.moanClips.PlayRandom(allowRepeat:true);
	        if(ReadMyLips.singleton.enabled) ReadMyLips.Stimulate(sexSlapIntensity*8f);
	        ReadMyLips.PlayMoan(true);
	        
	        sexSlapIntensity = 0f;
	        pussySlap = null;
        }
        
        private static IEnumerator SexSlap(){
	        AudioClip clip = buttSlapLibrary.GetRandomClip();
	        yield return new WaitForSeconds(.05f);
	        float volumeFactor = sexSlapIntensity*sexSlapIntensity*sexSlapVolume.val;
	        sexSlapAS.pitch = Mathf.Lerp(.6f, 1.2f, sexSlapIntensity);
	        sexSlapAS.PlayOneShot(clip, volumeFactor);
	        // if(globalSlapMoanReactionEnabled.val) AudioManager.moanClips.PlayRandom(allowRepeat:true);
	        if(ReadMyLips.singleton.enabled) ReadMyLips.Stimulate(sexSlapIntensity*6f);
	        ReadMyLips.PlayMoan(true);
	        sexSlapIntensity = 0f;
	        sexSlap = null;
        }

        private void Exclude(string uid, bool val)
        {
	        Atom atom = SuperController.singleton.GetAtomByUid(uid);
	        if (val)
	        {
		        if(!excludedAtoms.Contains(atom))
		        {
			        excludedAtoms.Add(atom);
			        excludedInfo.val = atom.uid + "\n" + excludedInfo.val;
		        }
	        }
	        else if(excludedAtoms.Remove(atom))
	        { 
		        excludedInfo.val = string.Join("\n", excludedAtoms.Select(x => x.uid).ToArray());
	        }
        }
        
        private void AddExclusionChoice(Atom atom)
        {
	        if (excludedChooser.choices.Contains(atom.uid)) return;
	        var choices = excludedChooser.choices;
	        choices.Insert(0, atom.uid);
	        excludedChooser.choices = new List<string>(choices);
        }

        private void ExcludeDefaults()
        {
	        string[] typesToExclude = {"Panel", "Slate", "Wall", "Glass", "CustomUnityAsset", "Apt", "Cyberpunk", "Deco"};
	        foreach (var atom in SuperController.singleton.GetAtoms())
	        {
		        if(typesToExclude.Any(x => atom.type.Contains(x))) Exclude(atom.uid, true);
	        }
        }
        
        private void SyncAtomNames(List<string> uids)
        {
	        excludedChooser.choices = new List<string>(uids);
	        var ignoredUids = excludedAtoms.Select(x => x.uid).ToArray();
	        excludedInfo.val = string.Join("\n", ignoredUids);
        }
        
        private void ResetExcluded()
        {
	        excludedAtoms.Clear();
	        excludedInfo.val = "";
        }

        private void OnDestroy()
        {
	        foreach(TouchZone touchZone in BodyRegionMapping.touchZones.Values.ToList()){
		        touchZone.Destroy();
	        }
            AudioImporter.UnloadBundles();
            SuperController.singleton.onAtomAddedHandlers -= AddExclusionChoice;
            SuperController.singleton.onAtomUIDsChangedHandlers -= SyncAtomNames;
            ReadMyLips.Reset();
            sexSlap.Stop();
            sexSlap = null;
            pussySlap.Stop();
            pussySlap = null;
        }
        
        public override void LateRestoreFromJSON(
	        JSONClass jc,
	        bool restorePhysical,
	        bool restoreAppearance,
	        bool setMissingToDefault
        )
        {
	        if (jc.HasKey("excludeInfo"))
	        {
		        ResetExcluded();
		        var uidsToIgnore = ((string)jc["excludeInfo"]).Split(new [] {"\n"}, StringSplitOptions.None);
		        foreach (var uid in uidsToIgnore)
		        {
			        Exclude(uid, true);
		        }
	        }
        }
    }
}